<template>
  <div class="edit-info-form">
    <Select :options="roles" v-model="role" id="role" dark label="نوع حساب" no-empty />
    <Button type="contained" size="lg" class="submit-button" @click.native="updateRole" :disabled="disabledButton">بروزرسانی</Button>
  </div>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import UploadIcon from "@/assets/svgs/upload.svg";
import Select from "@/components/base/Select";

export default {
  components: {
    Button,
    TextField,
    UploadIcon,
    Select
  },
  props: {
    user: {
      type: Object,
      required: true
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      oldRole: this.user.role ? { title: this.translateRole(this.user.role) }: {},
      role: this.user.role ? { title: this.translateRole(this.user.role) }: {},
      roles: [{ title: 'مدیر', id: 1 }, { title: 'کاربر عادی', id: 2 }]
    }
  },
  methods: {
    updateRole() {
      const token = this.$store.getters['auth/getToken'];
      const data = {
        role: this.getRole,
        token,
        id: this.user.id
      }
      this.$store.dispatch('auth/updateUserRole', data).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: 'مشخصات با موفقیت بروزرسانی شد!',
            light: true,
            type: 'success',
            timeout: 2500
          });
          console.log(response);
          this.$emit('update');
        } else if (response.status === 400) {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در بروزرسانی! لطفا ورودی های خود را کنترل کنید.',
            type: 'error',
            timeout: 3500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر تلاش کنید.',
            type: 'error',
            timeout: 3500
          });
        }
      }).catch(error => {
        this.$store.dispatch('notifications/push', {
          message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر تلاش کنید.',
          type: 'error',
          timeout: 3500
        });
      });
    },
    translateRole(role) {
      return role === "admin" ? "مدیر" : "کاربر عادی";
    }
  },
  computed: {
    getRole() {
      return this.role.title === "مدیر" ? "admin" : "user";
    },
    hasRoleChanged() {
      return this.oldRole.title !== this.role.title ? true : false;
    },
    disabledButton() {
      return this.hasRoleChanged && !this.disabled ? false : true;
    }
  },
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"
.field
  direction ltr
  &:not(:last-of-type)
    margin-bottom $md

.submit-button
  margin-top $md 
  width 100%
</style>